<?php
/**
 * @version		1.5.3.48 controllers/users.php
 * @package		J2XML
 * @subpackage	com_j2xml
 * @since		1.5.3
 * 
 * @author		Helios Ciancio <info@eshiol.it>
 * @link		http://www.eshiol.it
 * @copyright	Copyright (C) 2010 Helios Ciancio. All Rights Reserved
 * @license		http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL v3
 * J2XML is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */
 
// no direct access
defined('_JEXEC') or die('Restricted access.');

jimport('joomla.application.component.controller');

require_once (JPATH_COMPONENT.DS.'helpers'.DS.'version.php');
require_once (JPATH_COMPONENT.DS.'helpers'.DS.'exporter.php');
require_once (JPATH_COMPONENT.DS.'helpers'.DS.'sender.php');

/**
 * Content controller class.
 *
 * @package		J2XML.Administrator
 * @subpackage	com_j2xml
 * @since		1.5.3beta4.39
 */
class J2XMLControllerUsers extends JController
{
	function __construct($default = array())
	{
		parent::__construct();
	}

	function display()
	{
		JRequest::setVar('view', 'users');
		parent::display();
	}
	

	/**
	 * Export users in XML format
	 */
	function export()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');

		$cid = JRequest::getVar('cid', array(0), 'post', 'array');
		$id = 'cid='.implode(',', $cid);
		$this->setRedirect('index.php?option=com_j2xml&task=users.display&format=raw&'.$id);
	}

	/**
	 * Send users in XML format
	 */
	function send()
	{		
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');
		
		$ids = JRequest::getVar('cid');		
		$sid = JRequest::getVar('j2xml_send_id');
		
		$params =& JComponentHelper::getParams('com_j2xml');
		$images = array();

		$xml = J2XMLExporter::users($ids);
		$res = J2XMLSender::send(
				$xml,		
				$params->get('debug', 0), 
				$params->get('export_gzip', '0'),
				$sid
			);
		if ($res || $params->get('debug') == 0)
			$this->setRedirect(@$_SERVER['HTTP_REFERER']);		
	}
}
?>
