sprintfWrapper = {


	init : function () {
 		if (typeof arguments == "undefined") { return null; }
		if (arguments.length < 1) { return null; }
		if (typeof arguments[0] != "string") { return null; }
		if (typeof RegExp == "undefined") { return null; }
 
		var string = arguments[0];
		var exp = new RegExp(/(%([%]|(\-)?(\+|\x20)?(0)?(\d+)?(\.(\d)?)?([bcdfosxX])))/g);
		var matches = new Array();
		var strings = new Array();
		var convCount = 0;
		var stringPosStart = 0;
		var stringPosEnd = 0;
		var matchPosEnd = 0;
		var newString = '';
		var match = null;

		while (match = exp.exec(string)) {
			if (match[9]) { convCount += 1; }
 
			stringPosStart = matchPosEnd;
			stringPosEnd = exp.lastIndex - match[0].length;
			strings[strings.length] = string.substring(stringPosStart, stringPosEnd);
 
			matchPosEnd = exp.lastIndex;
			matches[matches.length] = {
				match: match[0],
				left: match[3] ? true : false,
				sign: match[4] || '',
				pad: match[5] || ' ',
				min: match[6] || 0,
				precision: match[8],
				code: match[9] || '%',
				negative: parseInt(arguments[convCount]) < 0 ? true : false,
				argument: String(arguments[convCount])
			};
		}
		strings[strings.length] = string.substring(matchPosEnd);
 
		if (matches.length == 0) { return string; }
		if ((arguments.length - 1) < convCount) { return null; }
 
		var code = null;
		var match = null;
		var i = null;
 
		for (i=0; i<matches.length; i++) {
 
			if (matches[i].code == '%') { substitution = '%' }
			else if (matches[i].code == 'b') {
				matches[i].argument = String(Math.abs(parseInt(matches[i].argument)).toString(2));
				substitution = sprintfWrapper.convert(matches[i], true);
			}
			else if (matches[i].code == 'c') {
				matches[i].argument = String(String.fromCharCode(parseInt(Math.abs(parseInt(matches[i].argument)))));
				substitution = sprintfWrapper.convert(matches[i], true);
			}
			else if (matches[i].code == 'd') {
				matches[i].argument = String(Math.abs(parseInt(matches[i].argument)));
				substitution = sprintfWrapper.convert(matches[i]);
			}
			else if (matches[i].code == 'f') {
				matches[i].argument = String(Math.abs(parseFloat(matches[i].argument)).toFixed(matches[i].precision ? matches[i].precision : 6));
				substitution = sprintfWrapper.convert(matches[i]);
			}
			else if (matches[i].code == 'o') {
				matches[i].argument = String(Math.abs(parseInt(matches[i].argument)).toString(8));
				substitution = sprintfWrapper.convert(matches[i]);
			}
			else if (matches[i].code == 's') {
				matches[i].argument = matches[i].argument.substring(0, matches[i].precision ? matches[i].precision : matches[i].argument.length)
				substitution = sprintfWrapper.convert(matches[i], true);
			}
			else if (matches[i].code == 'x') {
				matches[i].argument = String(Math.abs(parseInt(matches[i].argument)).toString(16));
				substitution = sprintfWrapper.convert(matches[i]);
			}
			else if (matches[i].code == 'X') {
				matches[i].argument = String(Math.abs(parseInt(matches[i].argument)).toString(16));
				substitution = sprintfWrapper.convert(matches[i]).toUpperCase();
			}
			else {
				substitution = matches[i].match;
			}
 
			newString += strings[i];
			newString += substitution;
 
		}
		newString += strings[i];
 
		return newString;
 
	},
 
	convert : function(match, nosign){
		if (nosign) {
			match.sign = '';
		} else {
			match.sign = match.negative ? '-' : match.sign;
		}
		var l = match.min - match.argument.length + 1 - match.sign.length;
		var pad = new Array(l < 0 ? 0 : l).join(match.pad);
		if (!match.left) {
			if (match.pad == "0" || nosign) {
				return match.sign + pad + match.argument;
			} else {
				return pad + match.sign + match.argument;
			}
		} else {
			if (match.pad == "0" || nosign) {
				return match.sign + match.argument + pad.replace(/0/g, ' ');
			} else {
				return match.sign + match.argument + pad;
			}
		}
	}
}
 
sprintf = sprintfWrapper.init;

var ExtensionUpdater = {
	initialize: function(linkdiv, responsediv) {
		this.fields = new Array();
		if (linkdiv == null) return false;
		if (responsediv == null) return false;
		$(linkdiv).addEvent('click', function(event) {
			$(responsediv).set('html', '<img src="components/com_j2xml/assets/images/loading.gif" /> ' + ExtensionUpdater.get('msgChecking4Updates'));
			$(linkdiv).hide();
			//prevent the page from changing 
			event.stop();
			//make the ajax call 
			var rpc = new XMLRPC.call({
				url: ExtensionUpdater.get('url'),
				onSuccess: function(response, responseText) {
					if (version_compare(ExtensionUpdater.get('version'), response['version'], '>='))
						$(responsediv).set('html', ExtensionUpdater.get('msgLatestInstalled'));
					else if (response['directdownload'] == 1)
						$(responsediv).set('html', sprintf(ExtensionUpdater.get('msgNewerAvailable'), response['version']) + ' <a href="#" onclick="submitInstall(\'' + response['href'] + '\')">' + ExtensionUpdater.get('msgUpdate') + '</a>');
					else
						$(responsediv).set('html', sprintf(ExtensionUpdater.get('msgNewerAvailable'), response['version']) + ' <a target="_blank" href="' + response['href'] + '">' + ExtensionUpdater.get('msgDownload') + '</a>');
				},
				onFailure: function(xhr) {
					if (xhr.status == 0)
						$(responsediv).set('html', ExtensionUpdater.get('msgFailed2Check'));
					else
						$(responsediv).set('html', ExtensionUpdater.get('msgFailed2Check') + ': ' + xhr.status + ' - ' + xhr.statusText);
					$(linkdiv).show();
				}
			}).send('files.searchlatestversion', 
					ExtensionUpdater.get('auth') 
						? 
						[ExtensionUpdater.get('keyref'), ExtensionUpdater.get('auth')] 
						: 
						[ExtensionUpdater.get('keyref')]
					);
		});
	},
	
	set: function(field, value) {
		this.fields[field] = value;
		if (Browser.Engine.gecko)
			console.log('ExtensionUpdater.set: ' + field+' = '+this.get(field));
	},
	
	get: function(field) {
		return this.fields[field];
	}
}

function submitInstall(url)
{
	var form = document.adminForm;
	form.task.value='doInstall';
	form.option.value='com_installer';
	//form.controller.value='';
	if (ExtensionUpdater.get('auth'))
		url = url+ '&auth=' + ExtensionUpdater.get('auth');
	form.install_url.value=url;
	form.submit();
}

window.addEvent('domready', function() {
	//time to implement basic show / hide
	Element.implement({
		//implement show
		show: function() {
			this.setStyle('display','');
		},
		//implement hide
		hide: function() {
			this.setStyle('display','none');
		}
	});
});
